<template>
	<view class="content">
		<view class="top">
			<u-subsection mode="subsection" activeColor="#2979ff" :list="tabList" :current="curNow"
				@change="sectionChange"></u-subsection>
		</view>
		<view class="bottom">
			<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage">
				<view class="list-scroll-view">
					<view class="list" v-for="(item, index) in list" :key="index" @tap="toView(item)">
						<view class="rank" :class="[`rank${index+1}`]">TOP{{index+1}}</view>
						<view class="left">
							<image class="image" :src="item.file&&item.file.length>0?item.file[0].url:''">
							</image>
						</view>
						<view class="right">
							<view class="name textOver">{{item.series||'暂无'}} {{item.year||'暂无'}}款
								{{item.style||'暂无'}}
							</view>
							<view class="other">
								<text v-if="item.year">{{item.year||'暂无'}}年 | </text>
								<text v-if="item.mileage">{{item.mileage||'暂无'}}万公里 | </text>
								<text v-if="item.place">{{item.place||'暂无'}}</text>
							</view>
							<view class="money">
								<text>{{item.total_money||'0'}}</text>
								<text>万</text>
							</view>
						</view>
					</view>
					<view class="is_bottom" v-if="is_bottom">
						<text>{{config.bottom_title||'没有更多了！'}}</text>
					</view>
				</view>
			</scroll-view>
		</view>
	</view>
</template>

<script setup lang="ts">
	import { getCurrentInstance, ref } from 'vue';
	//该依赖已内置不需要单独安装
	import { onLoad } from "@dcloudio/uni-app";
	// 请求接口
	const $api = getCurrentInstance()?.appContext.config.globalProperties.$api;
	const $config = getCurrentInstance()?.appContext.config.globalProperties.$config;
	const tabList = ref(['销量榜', '保值榜', '店铺规模榜']);
	const curNow = ref(0);
	// 基本信息
	const config = ref({ logoUrl: [] });
	// 列表
	const list = ref([]);
	const total = ref(0);
	const skip = ref(0);
	const limit = ref(6);
	const page = ref(0);
	// 数据是否触底
	const is_bottom = ref(false);
	const scrollTop = ref(0);
	onLoad(async () => {
		await searchConfig();
		await search();
	})
	// config信息
	const searchConfig = async () => {
		config.value = uni.getStorageSync('config');
	};
	// 查询
	const search = async () => {
		const info = {
			skip: skip.value,
			limit: limit.value,
			status: '0'
		}
		const res = await $api('car', 'GET', info);
		if (res.errcode === 0) {
			list.value = list.value.concat(res.data)
			total.value = res.total
		} else {
			uni.showToast({
				title: res.errmsg || '',
				icon: 'error',
			});
		}
	};
	const toRoute = (item) => {
		uni.navigateTo({
			url: `/${item.route}`,
		})
	};
	// 跳转
	const sectionChange = (index) => {
		curNow.value = index;
	};
	// 查看详情
	const toView = (item) => {
		uni.navigateTo({
			url: `/pagesHome/car/index?id=${item.id || item._id}`
		})
	};
	// 联系卖家
	const toChat = (item) => {
		uni.makePhoneCall({
			phoneNumber: item.shop || '110',
			success: function () {
				console.log('拨打电话成功');
			},
			fail: function () {
				uni.showToast({
					title: '拨打电话失败',
					icon: 'error',
				});
			}
		});
	};
	// 清空失效数据
	const toDelete = () => {
		console.log('清空失效数据');
	};
	// 分页
	const toPage = () => {
		if (total.value > list.value.length) {
			uni.showLoading({
				title: '加载中',
				mask: true
			})
			page.value = page.value + 1;
			skip.value = page.value * limit.value;
			search();
			uni.hideLoading();
		} else is_bottom.value = true
	};
	// 清空列表
	const clearPage = () => {
		list.value = []
		skip.value = 0
		limit.value = 6
		page.value = 0
	};
</script>
<style lang="scss" scoped>
	.content {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.top {
			padding: 2vw;
		}

		.bottom {
			position: relative;
			flex-grow: 1;

			.list {
				position: relative;
				display: flex;
				margin: 2vw 0 0 0;
				padding: 2vw 2vw 0 2vw;

				.rank {
					position: absolute;
					top: -2px;
					left: 2px;
					padding: 2px 4px;
					font-size: var(--font14Size);
					color: var(--mainColor);
					font-weight: bold;
					background-color: var(--f99Color);
					border-top-left-radius: 8px;
					/* 左上角 */
					border-bottom-right-radius: 8px;
					/* 右下角 */
				}

				.rank1 {
					background-color: #817AE3;
				}

				.rank2 {
					background-color: #FF6A88;
				}

				.rank3 {
					background-color: #FBAB7E;
				}


				.left {
					.image {
						width: 100px;
						height: 70px;
						border-radius: 2px;
					}
				}

				.right {
					display: flex;
					flex-direction: column;
					justify-content: space-between;
					margin: 0 0 0 2vw;
					width: 100%;

					.name {
						font-size: var(--font14Size);
					}

					.other {
						color: var(--f85Color);
						font-size: var(--font12Size);
					}

					.money {
						color: var(--fF0Color);
						font-size: var(--font12Size);

						text:first-child {
							font-size: var(--font18Size);
						}
					}
				}
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.is_bottom {
		width: 100%;
		text-align: center;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: var(--f85Color);
			font-size: var(--font12Size);
		}
	}
</style>